module SecondFactor
  class TOTP
    def self.generate(secret_based)
      now_step = Time.now.to_i / 30

      return [
        SecondFactor::HOTP.generate(secret_based, now_step.pred),
        SecondFactor::HOTP.generate(secret_based, now_step),
        SecondFactor::HOTP.generate(secret_based, now_step.succ)
      ]
    end

    def self.verify(secret_based, token)
      challenges = self.generate(secret_based)
      return challenges.include? token
    end
  end
end
